﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace MusicPlay
{
    public partial class MusicDown : Form
    {
        public MusicDown()
        {
            InitializeComponent();
        }

        Main f1 = null;
        ListView lv = null;
        private void MusicDown_Load(object sender, EventArgs e)
        {
            f1 = (Main)this.Owner;
            lv = f1.lv_MusicDown;

            string downloadPath = lv.FocusedItem.SubItems[3].Text;
            string fileName = lv.FocusedItem.SubItems[1].Text;
            string suffix = ".mp3";
            textBox1.Text = downloadPath;
            textBox2.Text = fileName + suffix;
            textBox3.Text = System.AppDomain.CurrentDomain.BaseDirectory; 
        }

        private void button3_Click(object sender, EventArgs e)
        {
            button3.Enabled = false;
            DownloadFile(textBox1.Text, textBox3.Text + "\\" + textBox2.Text, progressBar1, label5,label7, label9);
            
            string savePath =  textBox3.Text+textBox2.Text; //将下载保存的地址返回给listview中
            lv.FocusedItem.SubItems[3].Text = savePath; //将本地的mp3地址返回
        }

        /*
		 * url 下载地址
		 * filename 文件地址
		 * prog 进度条
		 * fileSize 文件大小
		 * downSpeed 下载速度
		 * schedule 下载进度
		 * download 已下载
		 * meanSpeed 平均速度
		 * RemTime 剩余时间
		*/
        public void DownloadFile(string URL, string filename, System.Windows.Forms.ProgressBar prog, System.Windows.Forms.Label fileSize,System.Windows.Forms.Label schedule, System.Windows.Forms.Label download)
        {
            float percent = 0;
            try
            {
                System.Net.HttpWebRequest Myrq = (System.Net.HttpWebRequest)System.Net.HttpWebRequest.Create(URL);
                System.Net.HttpWebResponse myrp = (System.Net.HttpWebResponse)Myrq.GetResponse();
                long totalBytes = myrp.ContentLength;
                if (prog != null)
                {
                    prog.Maximum = (int)totalBytes;
                    fileSize.Text = "文件大小:" + (totalBytes / 1024) + "KB";
                }
                System.IO.Stream st = myrp.GetResponseStream();
                System.IO.Stream so = new System.IO.FileStream(filename, System.IO.FileMode.Create);
                long totalDownloadedByte = 0;
                byte[] by = new byte[1024];
                int osize = st.Read(by, 0, (int)by.Length);
                while (osize > 0)
                {
                    totalDownloadedByte = osize + totalDownloadedByte;
                    System.Windows.Forms.Application.DoEvents();
                    so.Write(by, 0, osize);
                    if (prog != null)
                    {
                        prog.Value = (int)totalDownloadedByte;
                    }
                    osize = st.Read(by, 0, (int)by.Length);
                    percent = (float)totalDownloadedByte / (float)totalBytes * 100;
                    schedule.Text = "已完成：" + percent.ToString() + "%";
                    download.Text = "已下载：" + (totalDownloadedByte / 1024) + "KB";
                    System.Windows.Forms.Application.DoEvents(); //必须加注这句代码，否则label1将因为循环执行太快而来不及显示信息
                }
                so.Close();
                st.Close();
                label4.Visible = true; //显示下载成功
            }
            catch (System.Exception)
            {
                throw;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.FolderBrowserDialog dialog = new System.Windows.Forms.FolderBrowserDialog();
            dialog.Description = "请选择文件夹";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (string.IsNullOrEmpty(dialog.SelectedPath))
                {
                    MessageBox.Show("文件夹路径不能为空");
                    return;
                }
                textBox3.Text = dialog.SelectedPath;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("explorer.exe", textBox3.Text);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
