﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace MusicPlay
{
    class TaskDown
    {
        public static int total; //计数

        /// <summary>
        /// 无参方法
        /// </summary>
        public TaskDown() 
        {
            
        }

        public TaskDown(string musicName,int num) 
        {
            total = num;
            SearchKuGou(musicName);
        }

        public static MusicPlay.Main.UpdateListDown update;
        public static MusicPlay.Main.UpdateLink upLink;

        /// <summary>
        /// 根据音乐名称搜索酷狗无损音乐
        /// </summary>
        /// <param name="musicName"></param>
        public void SearchKuGou(string musicName) 
        {
            //酷狗无损音乐开始搜索
            string url = "http://mobilecdn.kugou.com/api/v3/search/song?format=json&keyword=" + musicName + "&page=1&pagesize=90";
            string result = HttpHelper.Get(url);

            string regMusiNameStr = @"filename"":""(.*?)""";
            string regSingerStr = @"singername"":""(.*?)""";
            string reghash = @"""hash"":""(.*?)""";
            string reg320hash = @"320hash"":""(.*?)""";
            Regex reg = new Regex(regMusiNameStr);
            Regex reg2 = new Regex(regSingerStr);
            Regex reg3 = new Regex(reghash);
            Regex reg4 = new Regex(reg320hash);
            System.Text.RegularExpressions.MatchCollection matchMusicName = reg.Matches(result);
            System.Text.RegularExpressions.MatchCollection matchSinger = reg2.Matches(result);
            System.Text.RegularExpressions.MatchCollection matchHash = reg3.Matches(result);
            System.Text.RegularExpressions.MatchCollection match320hash = reg4.Matches(result);
            for (int i = 0; i < matchMusicName.Count; i++)
            {
                //序号
                ListViewItem item = new ListViewItem(total.ToString()); 

                //曲名
                string music_Name = matchMusicName[i].Groups[1].Value;
                item.SubItems.Add(music_Name);

                //歌手
                string singer = matchSinger[i].Groups[1].Value;
                item.SubItems.Add(singer);

                string flac = match320hash[i].Groups[1].Value;
                if (flac != "") 
                {
                    string temp = GetKugouDownLoad(flac);

                    //过滤,没有无损就不添加
                    if (temp != "" && temp != null)
                    {
                        total = total + 1; //计数加1

                        item.SubItems.Add(temp);
                        
                        //更新界面UI
                        update(item);
                    }
                }
            }
            upLink(true);
        }

        /// <summary>
        /// 根据得到的酷狗hash值解析出无损音乐地址
        /// </summary>
        /// <param name="hash"></param>
        /// <returns></returns>
        private string GetKugouDownLoad(string hash) 
        {
            string keys = GetMD5(hash + "kgcloud");
            string url = "http://trackercdn.kugou.com/i/?cmd=4&hash=" + hash + "&key=" + keys + "&pid=1&forceDown=0&vip=1";
            string result = HttpHelper.Get(url);
            result = getSplitText(result, "url\":\"", "\",\"extName");
            if (result != null)
            {
                if (result.Contains("\\/"))
                {
                    result = result.Replace("\\/", "/");
                }
            }
            return result;
        }

        /// <summary>
        /// 计算hash值
        /// </summary>
        /// <param name="myString"></param>
        /// <returns></returns>
        public static string GetMD5(string myString)
        {
            if (myString == null)
            {
                return null;
            }

            MD5 md5Hash = MD5.Create();

            // 将输入字符串转换为字节数组并计算哈希数据 
            byte[] data = md5Hash.ComputeHash(Encoding.UTF8.GetBytes(myString));
            // 创建一个 Stringbuilder 来收集字节并创建字符串 
            StringBuilder sBuilder = new StringBuilder();
            // 循环遍历哈希数据的每一个字节并格式化为十六进制字符串 
            for (int i = 0; i < data.Length; i++)
            {
                sBuilder.Append(data[i].ToString("x2"));
            }

            // 返回十六进制字符串 
            return sBuilder.ToString();
        }

        /// <summary>
        /// 取出指定的文本
        /// </summary>
        /// <param name="str"></param>
        /// <param name="leftStr"></param>
        /// <param name="rightStr"></param>
        /// <returns></returns>
        private string getSplitText(string str, string leftStr, string rightStr)
        {
            if (str == "" || leftStr == "" || rightStr == "") { return null; }
            int a = str.IndexOf(leftStr, 0);
            int b = str.IndexOf(rightStr, a + 1);
            if (a < 0 || b < 0)
            { return null; }
            else
            {
                a = a + leftStr.Length;
                b = b - a;
                if (a < 0 || b < 0)
                { return null; }
                return str.Substring(a, b);
            }
        }
    }
}
